# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class Authority(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        Authority - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'host': 'Host',
            'port': 'int',
            'userinfo': 'str',
            'empty': 'bool'
        }

        self.attribute_map = {
            'host': 'host',
            'port': 'port',
            'userinfo': 'userinfo',
            'empty': 'empty'
        }

        self._host = None
        self._port = None
        self._userinfo = None
        self._empty = None

    @property
    def host(self):
        """
        Gets the host of this Authority.


        :return: The host of this Authority.
        :rtype: Host
        """
        return self._host

    @host.setter
    def host(self, host):
        """
        Sets the host of this Authority.


        :param host: The host of this Authority.
        :type: Host
        """
        self._host = host

    @property
    def port(self):
        """
        Gets the port of this Authority.


        :return: The port of this Authority.
        :rtype: int
        """
        return self._port

    @port.setter
    def port(self, port):
        """
        Sets the port of this Authority.


        :param port: The port of this Authority.
        :type: int
        """
        self._port = port

    @property
    def userinfo(self):
        """
        Gets the userinfo of this Authority.


        :return: The userinfo of this Authority.
        :rtype: str
        """
        return self._userinfo

    @userinfo.setter
    def userinfo(self, userinfo):
        """
        Sets the userinfo of this Authority.


        :param userinfo: The userinfo of this Authority.
        :type: str
        """
        self._userinfo = userinfo

    @property
    def empty(self):
        """
        Gets the empty of this Authority.


        :return: The empty of this Authority.
        :rtype: bool
        """
        return self._empty

    @empty.setter
    def empty(self, empty):
        """
        Sets the empty of this Authority.


        :param empty: The empty of this Authority.
        :type: bool
        """
        self._empty = empty

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

